diff --git a/gcc/tree-vect-stmts.c b/gcc/tree-vect-stmts.c
index ec9cc68..1b21253 100644
--- a/gcc/tree-vect-stmts.c
+++ b/gcc/tree-vect-stmts.c
@@ -7437,7 +7437,7 @@ free_stmt_vec_info (gimple stmt)
       if (patt_info)
 	{
 	  gimple_seq seq = STMT_VINFO_PATTERN_DEF_SEQ (patt_info);
-	  gimple patt_stmt = STMT_VINFO_STMT (patt_info);
+	  gimple *patt_stmt = STMT_VINFO_STMT (patt_info);
 	  gimple_set_bb (patt_stmt, NULL);
 	  tree lhs = gimple_get_lhs (patt_stmt);
 	  if (TREE_CODE (lhs) == SSA_NAME)
@@ -7447,7 +7447,7 @@ free_stmt_vec_info (gimple stmt)
 	      gimple_stmt_iterator si;
 	      for (si = gsi_start (seq); !gsi_end_p (si); gsi_next (&si))
 		{
-		  gimple seq_stmt = gsi_stmt (si);
+		  gimple *seq_stmt = gsi_stmt (si);
 		  gimple_set_bb (seq_stmt, NULL);
 		  lhs = gimple_get_lhs (patt_stmt);
 		  if (TREE_CODE (lhs) == SSA_NAME)
@@ -7584,8 +7584,8 @@ get_same_sized_vectype (tree scalar_type, tree vector_type)
    For now, operands defined outside the basic block are not supported.  */
 
 bool
-vect_is_simple_use (tree operand, gimple stmt, loop_vec_info loop_vinfo,
-                    bb_vec_info bb_vinfo, gimple *def_stmt,
+vect_is_simple_use (tree operand, gimple *stmt, loop_vec_info loop_vinfo,
+                    bb_vec_info bb_vinfo, gimple **def_stmt,
 		    tree *def, enum vect_def_type *dt)
 {
   basic_block bb;
@@ -7720,8 +7720,8 @@ vect_is_simple_use (tree operand, gimple stmt, loop_vec_info loop_vinfo,
    scalar operand.  */
 
 bool
-vect_is_simple_use_1 (tree operand, gimple stmt, loop_vec_info loop_vinfo,
-		      bb_vec_info bb_vinfo, gimple *def_stmt,
+vect_is_simple_use_1 (tree operand, gimple *stmt, loop_vec_info loop_vinfo,
+		      bb_vec_info bb_vinfo, gimple **def_stmt,
 		      tree *def, enum vect_def_type *dt, tree *vectype)
 {
   if (!vect_is_simple_use (operand, stmt, loop_vinfo, bb_vinfo, def_stmt,
@@ -7780,7 +7780,7 @@ vect_is_simple_use_1 (tree operand, gimple stmt, loop_vec_info loop_vinfo,
    widening operation (short in the above example).  */
 
 bool
-supportable_widening_operation (enum tree_code code, gimple stmt,
+supportable_widening_operation (enum tree_code code, gimple *stmt,
 				tree vectype_out, tree vectype_in,
                                 enum tree_code *code1, enum tree_code *code2,
                                 int *multi_step_cvt,
@@ -7855,7 +7855,7 @@ supportable_widening_operation (enum tree_code code, gimple stmt,
              by STMT is only directly used in the reduction statement.  */
           tree lhs = gimple_assign_lhs (stmt);
           use_operand_p dummy;
-          gimple use_stmt;
+          gimple *use_stmt;
           stmt_vec_info use_stmt_info = NULL;
           if (single_imm_use (lhs, &dummy, &use_stmt)
               && (use_stmt_info = vinfo_for_stmt (use_stmt))
diff --git a/gcc/tree-vectorizer.c b/gcc/tree-vectorizer.c
index 8f5f2d6..e2bfc62 100644
--- a/gcc/tree-vectorizer.c
+++ b/gcc/tree-vectorizer.c
@@ -167,7 +167,7 @@ adjust_simduid_builtins (hash_table <simduid_to_vf> &htab)
 	{
 	  unsigned int vf = 1;
 	  enum internal_fn ifn;
-	  gimple stmt = gsi_stmt (i);
+	  gimple *stmt = gsi_stmt (i);
 	  tree t;
 	  if (!is_gimple_call (stmt)
 	      || !gimple_call_internal_p (stmt))
@@ -270,7 +270,7 @@ note_simd_array_uses (hash_table <simd_array_to_simduid> *htab)
   FOR_EACH_BB_FN (bb, cfun)
     for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
       {
-	gimple stmt = gsi_stmt (gsi);
+	gimple *stmt = gsi_stmt (gsi);
 	if (!is_gimple_call (stmt) || !gimple_call_internal_p (stmt))
 	  continue;
 	switch (gimple_call_internal_fn (stmt))
@@ -286,7 +286,7 @@ note_simd_array_uses (hash_table <simd_array_to_simduid> *htab)
 	if (lhs == NULL_TREE)
 	  continue;
 	imm_use_iterator use_iter;
-	gimple use_stmt;
+	gimple *use_stmt;
 	ns.simduid = DECL_UID (SSA_NAME_VAR (gimple_call_arg (stmt, 0)));
 	FOR_EACH_IMM_USE_STMT (use_stmt, use_iter, lhs)
 	  if (!is_gimple_debug (use_stmt))
@@ -322,11 +322,11 @@ vect_destroy_datarefs (loop_vec_info loop_vinfo, bb_vec_info bb_vinfo)
 /* If LOOP has been versioned during ifcvt, return the internal call
    guarding it.  */
 
-static gimple
+static gimple *
 vect_loop_vectorized_call (struct loop *loop)
 {
   basic_block bb = loop_preheader_edge (loop)->src;
-  gimple g;
+  gimple *g;
   do
     {
       g = last_stmt (bb);
@@ -359,12 +359,12 @@ vect_loop_vectorized_call (struct loop *loop)
    update any immediate uses of it's LHS.  */
 
 static void
-fold_loop_vectorized_call (gimple g, tree value)
+fold_loop_vectorized_call (gimple *g, tree value)
 {
   tree lhs = gimple_call_lhs (g);
   use_operand_p use_p;
   imm_use_iterator iter;
-  gimple use_stmt;
+  gimple *use_stmt;
   gimple_stmt_iterator gsi = gsi_for_stmt (g);
 
   update_call_from_tree (&gsi, value);
@@ -436,7 +436,7 @@ vectorize_loops (void)
         if (!dbg_cnt (vect_loop))
 	  break;
 
-	gimple loop_vectorized_call = vect_loop_vectorized_call (loop);
+	gimple *loop_vectorized_call = vect_loop_vectorized_call (loop);
 	if (loop_vectorized_call)
 	  {
 	    tree arg = gimple_call_arg (loop_vectorized_call, 1);
@@ -456,13 +456,13 @@ vectorize_loops (void)
 		for (gsi = gsi_start_phis (bb); !gsi_end_p (gsi);
 		     gsi_next (&gsi))
 		  {
-		    gimple phi = gsi_stmt (gsi);
+		    gimple *phi = gsi_stmt (gsi);
 		    gimple_set_uid (phi, 0);
 		  }
 		for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi);
 		     gsi_next (&gsi))
 		  {
-		    gimple stmt = gsi_stmt (gsi);
+		    gimple *stmt = gsi_stmt (gsi);
 		    gimple_set_uid (stmt, 0);
 		  }
 	      }
@@ -514,7 +514,7 @@ vectorize_loops (void)
 	loop = get_loop (cfun, i);
 	if (loop && loop->dont_vectorize)
 	  {
-	    gimple g = vect_loop_vectorized_call (loop);
+	    gimple *g = vect_loop_vectorized_call (loop);
 	    if (g)
 	      {
 		fold_loop_vectorized_call (g, boolean_false_node);
diff --git a/gcc/tree-vectorizer.h b/gcc/tree-vectorizer.h
index c5cb037..0f5fc7a 100644
--- a/gcc/tree-vectorizer.h
+++ b/gcc/tree-vectorizer.h
@@ -70,7 +70,7 @@ enum vect_def_type {
 typedef struct _stmt_info_for_cost {
   int count;
   enum vect_cost_for_stmt kind;
-  gimple stmt;
+  gimple *stmt;
   int misalign;
 } stmt_info_for_cost;
 
@@ -79,7 +79,7 @@ typedef vec<stmt_info_for_cost> stmt_vector_for_cost;
 
 static inline void
 add_stmt_info_to_vec (stmt_vector_for_cost *stmt_cost_vec, int count,
-		      enum vect_cost_for_stmt kind, gimple stmt, int misalign)
+		      enum vect_cost_for_stmt kind, gimple *stmt, int misalign)
 {
   stmt_info_for_cost si;
   si.count = count;
@@ -100,12 +100,12 @@ struct _slp_tree {
   /* Nodes that contain def-stmts of this node statements operands.  */
   vec<slp_tree> children;
   /* A group of scalar stmts to be vectorized together.  */
-  vec<gimple> stmts;
+  vec<gimple *> stmts;
   /* Load permutation relative to the stores, NULL if there is no
      permutation.  */
   vec<unsigned> load_permutation;
   /* Vectorized stmt/s.  */
-  vec<gimple> vec_stmts;
+  vec<gimple *> vec_stmts;
   /* Number of vector stmts that are created to replace the group of scalar
      stmts. It is calculated during the transformation phase as the number of
      scalar elements in one scalar iteration (GROUP_SIZE) multiplied by VF
@@ -134,7 +134,7 @@ typedef struct _slp_instance {
 
   /* The first scalar load of the instance. The created vector loads will be
      inserted before this statement.  */
-  gimple first_load;
+  gimple *first_load;
 } *slp_instance;
 
 
@@ -158,7 +158,7 @@ typedef struct _slp_instance {
 typedef struct _slp_oprnd_info
 {
   /* Def-stmts for the operands.  */
-  vec<gimple> def_stmts;
+  vec<gimple *> def_stmts;
   /* Information about the first statement, its vector def-type, type, the
      operand itself in case it's constant, and an indication if it's a pattern
      stmt.  */
@@ -310,11 +310,11 @@ typedef struct _loop_vec_info {
 
   /* Statements in the loop that have data references that are candidates for a
      runtime (loop versioning) misalignment check.  */
-  vec<gimple> may_misalign_stmts;
+  vec<gimple *> may_misalign_stmts;
 
   /* All interleaving chains of stores in the loop, represented by the first
      stmt in the chain.  */
-  vec<gimple> grouped_stores;
+  vec<gimple *> grouped_stores;
 
   /* All SLP instances in the loop. This is a subset of the set of GROUP_STORES
      of the loop.  */
@@ -325,11 +325,11 @@ typedef struct _loop_vec_info {
   unsigned slp_unrolling_factor;
 
   /* Reduction cycles detected in the loop. Used in loop-aware SLP.  */
-  vec<gimple> reductions;
+  vec<gimple *> reductions;
 
   /* All reduction chains in the loop, represented by the first
      stmt in the chain.  */
-  vec<gimple> reduction_chains;
+  vec<gimple *> reduction_chains;
 
   /* Hash table used to choose the best peeling option.  */
   hash_table <peel_info_hasher> peeling_htab;
@@ -428,7 +428,7 @@ loop_vec_info_for_loop (struct loop *loop)
 }
 
 static inline bool
-nested_in_vect_loop_p (struct loop *loop, gimple stmt)
+nested_in_vect_loop_p (struct loop *loop, gimple *stmt)
 {
   return (loop->inner
           && (loop->inner == (gimple_bb (stmt))->loop_father));
@@ -439,7 +439,7 @@ typedef struct _bb_vec_info {
   basic_block bb;
   /* All interleaving chains of stores in the basic block, represented by the
      first stmt in the chain.  */
-  vec<gimple> grouped_stores;
+  vec<gimple *> grouped_stores;
 
   /* All SLP instances in the basic block. This is a subset of the set of
      GROUP_STORES of the basic block.  */
@@ -549,7 +549,7 @@ typedef struct _stmt_vec_info {
   bool in_pattern_p;
 
   /* The stmt to which this info struct refers to.  */
-  gimple stmt;
+  gimple *stmt;
 
   /* The loop_vec_info with respect to which STMT is vectorized.  */
   loop_vec_info loop_vinfo;
@@ -558,7 +558,7 @@ typedef struct _stmt_vec_info {
   tree vectype;
 
   /* The vectorized version of the stmt.  */
-  gimple vectorized_stmt;
+  gimple *vectorized_stmt;
 
 
   /** The following is relevant only for stmts that contain a non-scalar
@@ -593,7 +593,7 @@ typedef struct _stmt_vec_info {
         related_stmt of the "pattern stmt" points back to this stmt (which is
         the last stmt in the original sequence of stmts that constitutes the
         pattern).  */
-  gimple related_stmt;
+  gimple *related_stmt;
 
   /* Used to keep a sequence of def stmts of a pattern stmt if such exists.  */
   gimple_seq pattern_def_seq;
@@ -613,12 +613,12 @@ typedef struct _stmt_vec_info {
 
   /* Interleaving and reduction chains info.  */
   /* First element in the group.  */
-  gimple first_element;
+  gimple *first_element;
   /* Pointer to the next element in the group.  */
-  gimple next_element;
+  gimple *next_element;
   /* For data-refs, in case that two or more stmts share data-ref, this is the
      pointer to the previously detected stmt with the same dr.  */
-  gimple same_dr_stmt;
+  gimple *same_dr_stmt;
   /* The size of the group.  */
   unsigned int size;
   /* For stores, number of stores from this group seen. We vectorize the last
@@ -728,7 +728,7 @@ void free_stmt_vec_info_vec (void);
 /* Return a stmt_vec_info corresponding to STMT.  */
 
 static inline stmt_vec_info
-vinfo_for_stmt (gimple stmt)
+vinfo_for_stmt (gimple *stmt)
 {
   unsigned int uid = gimple_uid (stmt);
   if (uid == 0)
@@ -740,7 +740,7 @@ vinfo_for_stmt (gimple stmt)
 /* Set vectorizer information INFO for STMT.  */
 
 static inline void
-set_vinfo_for_stmt (gimple stmt, stmt_vec_info info)
+set_vinfo_for_stmt (gimple *stmt, stmt_vec_info info)
 {
   unsigned int uid = gimple_uid (stmt);
   if (uid == 0)
@@ -756,8 +756,8 @@ set_vinfo_for_stmt (gimple stmt, stmt_vec_info info)
 
 /* Return the earlier statement between STMT1 and STMT2.  */
 
-static inline gimple
-get_earlier_stmt (gimple stmt1, gimple stmt2)
+static inline gimple *
+get_earlier_stmt (gimple *stmt1, gimple *stmt2)
 {
   unsigned int uid1, uid2;
 
@@ -784,8 +784,8 @@ get_earlier_stmt (gimple stmt1, gimple stmt2)
 
 /* Return the later statement between STMT1 and STMT2.  */
 
-static inline gimple
-get_later_stmt (gimple stmt1, gimple stmt2)
+static inline gimple *
+get_later_stmt (gimple *stmt1, gimple *stmt2)
 {
   unsigned int uid1, uid2;
 
@@ -816,7 +816,7 @@ get_later_stmt (gimple stmt1, gimple stmt2)
 static inline bool
 is_pattern_stmt_p (stmt_vec_info stmt_info)
 {
-  gimple related_stmt;
+  gimple *related_stmt;
   stmt_vec_info related_stmt_info;
 
   related_stmt = STMT_VINFO_RELATED_STMT (stmt_info);
@@ -989,22 +989,22 @@ extern bool vect_can_advance_ivs_p (loop_vec_info);
 extern unsigned int current_vector_size;
 extern tree get_vectype_for_scalar_type (tree);
 extern tree get_same_sized_vectype (tree, tree);
-extern bool vect_is_simple_use (tree, gimple, loop_vec_info,
-			        bb_vec_info, gimple *,
+extern bool vect_is_simple_use (tree, gimple *, loop_vec_info,
+			        bb_vec_info, gimple **,
                                 tree *,  enum vect_def_type *);
-extern bool vect_is_simple_use_1 (tree, gimple, loop_vec_info,
-				  bb_vec_info, gimple *,
+extern bool vect_is_simple_use_1 (tree, gimple *, loop_vec_info,
+				  bb_vec_info, gimple **,
 				  tree *,  enum vect_def_type *, tree *);
-extern bool supportable_widening_operation (enum tree_code, gimple, tree, tree,
+extern bool supportable_widening_operation (enum tree_code, gimple *, tree, tree,
                                             enum tree_code *, enum tree_code *,
 					    int *, vec<tree> *);
 extern bool supportable_narrowing_operation (enum tree_code, tree, tree,
 					     enum tree_code *,
 					     int *, vec<tree> *);
-extern stmt_vec_info new_stmt_vec_info (gimple stmt, loop_vec_info,
+extern stmt_vec_info new_stmt_vec_info (gimple *stmt, loop_vec_info,
                                         bb_vec_info);
-extern void free_stmt_vec_info (gimple stmt);
-extern tree vectorizable_function (gimple, tree, tree);
+extern void free_stmt_vec_info (gimple *stmt);
+extern tree vectorizable_function (gimple *, tree, tree);
 extern void vect_model_simple_cost (stmt_vec_info, int, enum vect_def_type *,
                                     stmt_vector_for_cost *,
 				    stmt_vector_for_cost *);
@@ -1018,18 +1018,18 @@ extern void vect_model_load_cost (stmt_vec_info, int, bool, slp_tree,
 extern unsigned record_stmt_cost (stmt_vector_for_cost *, int,
 				  enum vect_cost_for_stmt, stmt_vec_info,
 				  int, enum vect_cost_model_location);
-extern void vect_finish_stmt_generation (gimple, gimple,
+extern void vect_finish_stmt_generation (gimple *, gimple *,
                                          gimple_stmt_iterator *);
 extern bool vect_mark_stmts_to_be_vectorized (loop_vec_info);
-extern tree vect_get_vec_def_for_operand (tree, gimple, tree *);
-extern tree vect_init_vector (gimple, tree, tree,
+extern tree vect_get_vec_def_for_operand (tree, gimple *, tree *);
+extern tree vect_init_vector (gimple *, tree, tree,
                               gimple_stmt_iterator *);
 extern tree vect_get_vec_def_for_stmt_copy (enum vect_def_type, tree);
-extern bool vect_transform_stmt (gimple, gimple_stmt_iterator *,
+extern bool vect_transform_stmt (gimple *, gimple_stmt_iterator *,
                                  bool *, slp_tree, slp_instance);
-extern void vect_remove_stores (gimple);
-extern bool vect_analyze_stmt (gimple, bool *, slp_tree);
-extern bool vectorizable_condition (gimple, gimple_stmt_iterator *, gimple *,
+extern void vect_remove_stores (gimple *);
+extern bool vect_analyze_stmt (gimple *, bool *, slp_tree);
+extern bool vectorizable_condition (gimple *, gimple_stmt_iterator *, gimple **,
                                     tree, int, slp_tree);
 extern void vect_get_load_cost (struct data_reference *, int, bool,
 				unsigned int *, unsigned int *,
@@ -1038,7 +1038,7 @@ extern void vect_get_load_cost (struct data_reference *, int, bool,
 extern void vect_get_store_cost (struct data_reference *, int,
 				 unsigned int *, stmt_vector_for_cost *);
 extern bool vect_supportable_shift (enum tree_code, tree);
-extern void vect_get_vec_defs (tree, tree, gimple, vec<tree> *,
+extern void vect_get_vec_defs (tree, tree, gimple *, vec<tree> *,
 			       vec<tree> *, slp_tree, int);
 extern tree vect_gen_perm_mask (tree, unsigned char *);
 
@@ -1046,7 +1046,7 @@ extern tree vect_gen_perm_mask (tree, unsigned char *);
 extern bool vect_can_force_dr_alignment_p (const_tree, unsigned int);
 extern enum dr_alignment_support vect_supportable_dr_alignment
                                            (struct data_reference *, bool);
-extern tree vect_get_smallest_scalar_type (gimple, HOST_WIDE_INT *,
+extern tree vect_get_smallest_scalar_type (gimple *, HOST_WIDE_INT *,
                                            HOST_WIDE_INT *);
 extern bool vect_analyze_data_ref_dependences (loop_vec_info, int *);
 extern bool vect_slp_analyze_data_ref_dependences (bb_vec_info);
@@ -1055,46 +1055,46 @@ extern bool vect_analyze_data_refs_alignment (loop_vec_info, bb_vec_info);
 extern bool vect_verify_datarefs_alignment (loop_vec_info, bb_vec_info);
 extern bool vect_analyze_data_ref_accesses (loop_vec_info, bb_vec_info);
 extern bool vect_prune_runtime_alias_test_list (loop_vec_info);
-extern tree vect_check_gather (gimple, loop_vec_info, tree *, tree *,
+extern tree vect_check_gather (gimple *, loop_vec_info, tree *, tree *,
 			       int *);
 extern bool vect_analyze_data_refs (loop_vec_info, bb_vec_info, int *,
 				    unsigned *);
-extern tree vect_create_data_ref_ptr (gimple, tree, struct loop *, tree,
+extern tree vect_create_data_ref_ptr (gimple *, tree, struct loop *, tree,
 				      tree *, gimple_stmt_iterator *,
-				      gimple *, bool, bool *);
-extern tree bump_vector_ptr (tree, gimple, gimple_stmt_iterator *, gimple, tree);
+				      gimple **, bool, bool *);
+extern tree bump_vector_ptr (tree, gimple *, gimple_stmt_iterator *, gimple *, tree);
 extern tree vect_create_destination_var (tree, tree);
 extern bool vect_grouped_store_supported (tree, unsigned HOST_WIDE_INT);
 extern bool vect_store_lanes_supported (tree, unsigned HOST_WIDE_INT);
 extern bool vect_grouped_load_supported (tree, unsigned HOST_WIDE_INT);
 extern bool vect_load_lanes_supported (tree, unsigned HOST_WIDE_INT);
-extern void vect_permute_store_chain (vec<tree> ,unsigned int, gimple,
+extern void vect_permute_store_chain (vec<tree> ,unsigned int, gimple *,
                                     gimple_stmt_iterator *, vec<tree> *);
-extern tree vect_setup_realignment (gimple, gimple_stmt_iterator *, tree *,
+extern tree vect_setup_realignment (gimple *, gimple_stmt_iterator *, tree *,
                                     enum dr_alignment_support, tree,
                                     struct loop **);
-extern void vect_transform_grouped_load (gimple, vec<tree> , int,
+extern void vect_transform_grouped_load (gimple *, vec<tree> , int,
                                          gimple_stmt_iterator *);
-extern void vect_record_grouped_load_vectors (gimple, vec<tree> );
+extern void vect_record_grouped_load_vectors (gimple *, vec<tree> );
 extern tree vect_get_new_vect_var (tree, enum vect_var_kind, const char *);
-extern tree vect_create_addr_base_for_vector_ref (gimple, gimple_seq *,
+extern tree vect_create_addr_base_for_vector_ref (gimple *, gimple_seq *,
                                                   tree, struct loop *);
 
 /* In tree-vect-loop.c.  */
 /* FORNOW: Used in tree-parloops.c.  */
 extern void destroy_loop_vec_info (loop_vec_info, bool);
-extern gimple vect_force_simple_reduction (loop_vec_info, gimple, bool, bool *);
+extern gimple *vect_force_simple_reduction (loop_vec_info, gimple *, bool, bool *);
 /* Drive for loop analysis stage.  */
 extern loop_vec_info vect_analyze_loop (struct loop *);
 /* Drive for loop transformation stage.  */
 extern void vect_transform_loop (loop_vec_info);
 extern loop_vec_info vect_analyze_loop_form (struct loop *);
-extern bool vectorizable_live_operation (gimple, gimple_stmt_iterator *,
-                                         gimple *);
-extern bool vectorizable_reduction (gimple, gimple_stmt_iterator *, gimple *,
+extern bool vectorizable_live_operation (gimple *, gimple_stmt_iterator *,
+                                         gimple **);
+extern bool vectorizable_reduction (gimple *, gimple_stmt_iterator *, gimple **,
                                     slp_tree);
-extern bool vectorizable_induction (gimple, gimple_stmt_iterator *, gimple *);
-extern tree get_initial_def_for_reduction (gimple, tree, tree *);
+extern bool vectorizable_induction (gimple *, gimple_stmt_iterator *, gimple **);
+extern tree get_initial_def_for_reduction (gimple *, tree, tree *);
 extern int vect_min_worthwhile_factor (enum tree_code);
 extern int vect_get_known_peeling_cost (loop_vec_info, int, int *, int,
 					stmt_vector_for_cost *,
@@ -1122,7 +1122,7 @@ extern void vect_slp_transform_bb (basic_block);
 /* Pattern recognition functions.
    Additional pattern recognition functions can (and will) be added
    in the future.  */
-typedef gimple (* vect_recog_func_ptr) (vec<gimple> *, tree *, tree *);
+typedef gimple *(* vect_recog_func_ptr) (vec<gimple *> *, tree *, tree *);
 #define NUM_PATTERNS 11
 void vect_pattern_recog (loop_vec_info, bb_vec_info);
 
